/* simple hack for a single base Generalized Fermat Numbers (b>2) in lieu of Fermat (b=2) */

/* build five separate binaries, setting -DBASE=3 (5,6,10,12) */
/* TODO: refactor to make all bases (2,3,5,7,11) available at once and use linear combinations of residues */
/* for xGFN(m,a,b) = a^(2^m) + b^(2^m) */

/* all of these numbers have the same restricted factors (k*2^N+1, N>=m+1), so George's sieve stays all the same */

#ifndef BASE
#define BASE 6
#endif

/* BASE^(2^3) for faster validation */
#define BASE_n0 3
#define BASE_v0 (BASE*BASE*BASE*BASE * BASE*BASE*BASE*BASE)

/* BASE^(2^BASE_n1) as a 48-bit array for tf_f* kernels; n2 is the larger variant for larger kernels */
#if (BASE == 3)
#define BASE_n1 5
#define BASE_preinit a.d2 = 0; a.d1 = 0x6954F; a.d0 = 0xE21E3E81
#define BASE_n2 6
#define BASE_preinit2 a.d4 = 0; a.d3 = 0x2B; a.d2 = 0x56D4AF8F; a.d1 = 0x7932278C; a.d0 = 0x797EBD01
#endif

#if (BASE == 5)
#define BASE_n1 5
#define BASE_preinit a.d2 = 0x4EE; a.d1 = 0x2D6D415B; a.d0 = 0x85ACEF81
#define BASE_n2 6
#define BASE_preinit2 a.d4 = 0x184F03; a.d3 = 0xE93FF9F4; a.d2 = 0xDAA797ED; a.d1 = 0x6E38ED64; a.d0 = 0xBF6A1F01
#endif

#if (BASE == 6)
#define BASE_n1 5
#define BASE_preinit a.d2 = 0x6954F; a.d1 = 0xE21E3E81; a.d0 = 0
#define BASE_n2 5
#define BASE_preinit2 a.d4 = a.d3 = 0; a.d2 = 0x6954F; a.d1 = 0xE21E3E81; a.d0 = 0x0
#endif

#if (BASE == 10)
#define BASE_n1 4
#define BASE_preinit a.d2 = 0; a.d1 = 0x2386F2; a.d0 = 0x6FC10000
#define BASE_n2 5
#define BASE_preinit2 a.d4 = 0; a.d3 = 0x4EE; a.d2 = 0x2D6D415B; a.d1 = 0x85ACEF81; a.d0 = 0
#endif

#if (BASE == 12)
#define BASE_n1 4
#define BASE_preinit a.d2 = 0; a.d1 = 0x290D741; a.d0 = 0
#define BASE_n2 5
#define BASE_preinit2 a.d4 = 0; a.d3 = 0x6954F; a.d2 = 0xE21E3E81; a.d1 = a.d0 = 0
#endif

